/*	
 *	main.c
 *
 *	USB}EX
 *	Copyright (c) 2002 Naoyuki Sawa
 *
 *	* Mon Aug 19 05:38:00 JST 2002 Naoyuki Sawa
 *	- 1st [XB
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h> /* vsmcvals.h */
#include <piece.h>
#include <s1c33cpu.h>
#include <smcvals.h>
#include "c33209.h"
#include "d12ci.h"
#include "d12sys.h"

extern USBINFO ui;	/* d12usr.cŒ` */

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */

/* bZ[W\p */
#define N_LINES (DISP_Y / 6 + 1)
char lines[N_LINES][256];
int i_line;
void log(const char* fmt, ...) {
	va_list ap;
	va_start(ap, fmt);
	vsprintf(lines[i_line], fmt, ap);
	va_end(ap);
	i_line = (i_line + 1) % N_LINES;
}

void
pceAppInit()
{
	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(100);
	pceLCDDispStart();
}

void
pceAppProc(int count)
{
	int joy;
	int i;

	/* * pceAppInit()̒łȂtbNƁA
	 *   srft@CrunR}hŎsꍇɁArunR}h
	 *   vOJnołɃ^CAEgĂ܂܂B
	 *   runR}h^CAEgĂɖ͂܂񂪁A
	 *   CIɃCȂ̂ŁAx点ĂtbN܂B
	 * * pext@C̏ꍇ͂ȂtbNĂ\܂񂪁A
	 *   srfpex̔f̂ŁAx点邱Ƃɂ܂B
	 */
	if(count == 5) usb_hook(&ui);

	/* SELECT{^ꂽAI܂B */
	joy = pcePadGet();
	if(joy & TRG_SELECT) {
		pceAppReqExit(0);
		return;
	}

	/* bZ[W\B */
	memset(vbuff, 0, sizeof vbuff);
	pceFontSetType(0x82);
	for(i = 0; i < N_LINES; i++) {
		pceFontSetPos(0, i * 6 - 2);
		pceFontPutStr(lines[(i_line + i) % N_LINES]);
	}
	pceLCDTrans();
}

void
pceAppExit()
{
	/* mɃtbN܂B
	 * (܂tbNĂȂꍇɌĂłSł)
	 */
	usb_unhook();
}
